Attribute VB_Name = "DirectX"
'These three components are the big daddy of what your 3D Program.
Public DX_Main As New DirectX7 ' The DirectX core file (The heart of it all)
Public DD_Main As DirectDraw4 ' The DirectDraw Object
Public D3D_Main As Direct3DRM3 ' The direct3D Object

'DirectInput Components
Public DI_Main As DirectInput ' The DirectInput core
Public DI_Device As DirectInputDevice ' The DirectInput device
Public DI_State As DIKEYBOARDSTATE 'Array Holding the state of the keys

'DirectDraw Surfaces- Where the screen is drawn.
Public DS_Front As DirectDrawSurface4 ' The frontbuffer (What you see on the screen)
Public DS_Back As DirectDrawSurface4 ' The backbuffer, (Where everything is drawn before it's put on the screen.)
Public SD_Front As DDSURFACEDESC2 ' The SurfaceDescription
Public DD_Back As DDSCAPS2 ' General Surface Info

'ViewPort and Direct3D Device
Public D3D_Device As Direct3DRMDevice3 'The Main Direct3D Retained Mode Device
Public D3D_ViewPort As Direct3DRMViewport2 'The Direct3D Retained Mode Viewport (Kinda the camera)

'The Frames
Public FR_Root As Direct3DRMFrame3 'The Main Frame (The other frames are put under this one (Like a tree))
Public FR_Camera As Direct3DRMFrame3 'Another frame, just happens to be called 'camera'. We will use this
Public FR_Light As Direct3DRMFrame3 'This frame contains our, guess what, spotlight!
Public FR_Street As Direct3DRMFrame3 'Frame containing our 1st mesh that will be put in this "game".

'Lights
Public LT_Ambient As Direct3DRMLight 'Our Main (Ambient) light that illuminates everything (not just part of something
                                                'like a spotlight.
Public LT_Spot As Direct3DRMLight 'Our Spot light, makes it look more realistic.

'Camera Positions
Public xx As Long
Public yy As Long
Public zz As Long

Public esc As Boolean 'If Escape is pressed, the DX_Input sub will make it true and the main loop will end.
'Incase you haven't caught on, the prefix FR = frame, MS = Mesh, & LT = light.
'======================================================================================

Public Sub DX_Init(PixByX As Integer, PixByY As Integer)
 'Type, not copy and paste!
 'This sub will initialize all your components and set them up.
 Set DD_Main = DX_Main.DirectDraw4Create("") 'Create the DirectDraw Object

 DD_Main.SetCooperativeLevel frmMain.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE 'Set Screen Mode (Full 'Screen)
 DD_Main.SetDisplayMode PixByX, PixByY, 32, 0, DDSDM_DEFAULT 'Set Resolution and BitDepth (Lets use 32-bit color)
 
 SD_Front.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
 SD_Front.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_3DDEVICE Or DDSCAPS_COMPLEX Or DDSCAPS_FLIP
 SD_Front.lBackBufferCount = 1 'Make one backbuffer
 Set DS_Front = DD_Main.CreateSurface(SD_Front) 'Initialize the front buffer (the screen)
 'The Previous block of code just created the screen and the backbuffer.
 
 DD_Back.lCaps = DDSCAPS_BACKBUFFER
 Set DS_Back = DS_Front.GetAttachedSurface(DD_Back)
 DS_Back.SetForeColor RGB(255, 255, 255)
 'The backbuffer was initialized and the DirectDraw text color was set to white.

 Set D3D_Main = DX_Main.Direct3DRMCreate() 'Creates the Direct3D Retained Mode Object!!!!!

 Set D3D_Device = D3D_Main.CreateDeviceFromSurface("IID_IDirect3DHALDevice", DD_Main, DS_Back, _
 D3DRMDEVICE_DEFAULT) 'Tell the Direct3D Device that we are using hardware rendering (HALDevice) instead
                                   'of software enumeration (RGBDevice).
 D3D_Device.SetBufferCount 2 'Set the number of buffers
 D3D_Device.SetQuality D3DRMRENDER_GOURAUD 'Set Rendering Quality. Can use Flat, or WireFrame, but
                                                                  'GOURAUD has the best rendering quality.
 D3D_Device.SetTextureQuality D3DRMTEXTURE_NEAREST 'Set the texture quality
 D3D_Device.SetRenderMode D3DRMRENDERMODE_BLENDEDTRANSPARENCY 'Set the render mode.

 Set DI_Main = DX_Main.DirectInputCreate() 'Create the DirectInput Device
 Set DI_Device = DI_Main.CreateDevice("GUID_SysKeyboard") 'Set it to use the keyboard.
 DI_Device.SetCommonDataFormat DIFORMAT_KEYBOARD 'Set the data format to the keyboard format.
 DI_Device.SetCooperativeLevel frmMain.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE 'Set Coperative Level.
 DI_Device.Acquire
 'The above block of code configures the DirectInput Device and starts it.
 DS_Front.SetForeColor RGB(255, 255, 255) '220 310
 DS_Front.DrawBox 200, 220, 468, 330
 DS_Front.DrawText 200, 220, "Loading Crazziest Racing Game", False
 DS_Front.DrawText 200, 250, "Creating Frames...", False
 
End Sub

Public Sub DX_Exit()
    Call DD_Main.RestoreDisplayMode
    Call DD_Main.SetCooperativeLevel(frmMain.hWnd, DDSCL_NORMAL)
    Call DI_Device.Unacquire
    'Restore all the devices

    End 'Ends the program.
End Sub

Public Sub DX_Input()
 
 DI_Device.GetDeviceStateKeyboard DI_State 'Get the array of keyboard keys and their current states
  
 If DI_State.Key(DIK_ESCAPE) <> 0 Then Call DX_Exit 'If user presses [esc] then exit end the program.
 
 'If DI_State.Key(DIK_LEFT) <> 0 Then 'Quick Note: <> means 'does not'
 '  FR_Camera.SetOrientation FR_Camera, -Sin5, 0, Cos5, 0, 1, 0 'Rotate viewport/camera left
 'End If
 
 'If DI_State.Key(DIK_RIGHT) <> 0 Then
 '  FR_Camera.SetOrientation FR_Camera, Sin5, 0, Cos5, 0, 1, 0 'Rotate viewport/camera right
 'End If
 
 'If DI_State.Key(DIK_UP) <> 0 Then
  ' FR_Camera.SetPosition FR_Camera, 0, 0, 1 'Move the viewport forward
 'End If

 'If DI_State.Key(DIK_DOWN) <> 0 Then
 '  FR_Camera.SetPosition FR_Camera, 0, 0, -1 'Move the viewport back
' End If


End Sub
